diff --git a/sysdeps/unix/sysv/linux/sparc/sys/ptrace.h b/sysdeps/unix/sysv/linux/sparc/sys/ptrace.h
index c037734666e4..2d70d25b02bb 100644
--- a/sysdeps/unix/sysv/linux/sparc/sys/ptrace.h
+++ b/sysdeps/unix/sysv/linux/sparc/sys/ptrace.h
@@ -92,22 +92,22 @@ enum __ptrace_request
 
 #if __WORDSIZE == 32
 
-  /* Get all general purpose registers used by a processes.
+  /* Get all general purpose registers used by a process.
      This is not supported on all machines.  */
    PTRACE_GETREGS = 12,
 #define PT_GETREGS PTRACE_GETREGS
 
-  /* Set all general purpose registers used by a processes.
+  /* Set all general purpose registers used by a process.
      This is not supported on all machines.  */
    PTRACE_SETREGS = 13,
 #define PT_SETREGS PTRACE_SETREGS
 
-  /* Get all floating point registers used by a processes.
+  /* Get all floating point registers used by a process.
      This is not supported on all machines.  */
    PTRACE_GETFPREGS = 14,
 #define PT_GETFPREGS PTRACE_GETFPREGS
 
-  /* Set all floating point registers used by a processes.
+  /* Set all floating point registers used by a process.
      This is not supported on all machines.  */
    PTRACE_SETFPREGS = 15,
 #define PT_SETFPREGS PTRACE_SETFPREGS
@@ -133,12 +133,12 @@ enum __ptrace_request
 
 #if __WORDSIZE == 64
 
-  /* Get all general purpose registers used by a processes.
+  /* Get all general purpose registers used by a process.
      This is not supported on all machines.  */
    PTRACE_GETREGS = 22,
 #define PT_GETREGS PTRACE_GETREGS
 
-  /* Set all general purpose registers used by a processes.
+  /* Set all general purpose registers used by a process.
      This is not supported on all machines.  */
    PTRACE_SETREGS = 23,
 #define PT_SETREGS PTRACE_SETREGS
@@ -151,12 +151,12 @@ enum __ptrace_request
 
 #if __WORDSIZE == 64
 
-  /* Get all floating point registers used by a processes.
+  /* Get all floating point registers used by a process.
      This is not supported on all machines.  */
    PTRACE_GETFPREGS = 25,
 #define PT_GETFPREGS PTRACE_GETFPREGS
 
-  /* Set all floating point registers used by a processes.
+  /* Set all floating point registers used by a process.
      This is not supported on all machines.  */
    PTRACE_SETFPREGS = 26,
 #define PT_SETFPREGS PTRACE_SETFPREGS
diff --git a/sysdeps/unix/sysv/linux/sys/ptrace.h b/sysdeps/unix/sysv/linux/sys/ptrace.h
index 3c71a0ebd6de..bd7aa379240d 100644
--- a/sysdeps/unix/sysv/linux/sys/ptrace.h
+++ b/sysdeps/unix/sysv/linux/sys/ptrace.h
@@ -70,22 +70,22 @@ enum __ptrace_request
   PTRACE_SINGLESTEP = 9,
 #define PT_STEP PTRACE_SINGLESTEP
 
-  /* Get all general purpose registers used by a processes.
+  /* Get all general purpose registers used by a process.
      This is not supported on all machines.  */
   PTRACE_GETREGS = 12,
 #define PT_GETREGS PTRACE_GETREGS
 
-  /* Set all general purpose registers used by a processes.
+  /* Set all general purpose registers used by a process.
      This is not supported on all machines.  */
   PTRACE_SETREGS = 13,
 #define PT_SETREGS PTRACE_SETREGS
 
-  /* Get all floating point registers used by a processes.
+  /* Get all floating point registers used by a process.
      This is not supported on all machines.  */
   PTRACE_GETFPREGS = 14,
 #define PT_GETFPREGS PTRACE_GETFPREGS
 
-  /* Set all floating point registers used by a processes.
+  /* Set all floating point registers used by a process.
      This is not supported on all machines.  */
   PTRACE_SETFPREGS = 15,
 #define PT_SETFPREGS PTRACE_SETFPREGS
@@ -98,12 +98,12 @@ enum __ptrace_request
   PTRACE_DETACH = 17,
 #define PT_DETACH PTRACE_DETACH
 
-  /* Get all extended floating point registers used by a processes.
+  /* Get all extended floating point registers used by a process.
      This is not supported on all machines.  */
   PTRACE_GETFPXREGS = 18,
 #define PT_GETFPXREGS PTRACE_GETFPXREGS
 
-  /* Set all extended floating point registers used by a processes.
+  /* Set all extended floating point registers used by a process.
      This is not supported on all machines.  */
   PTRACE_SETFPXREGS = 19,
 #define PT_SETFPXREGS PTRACE_SETFPXREGS
diff --git a/sysdeps/unix/sysv/linux/x86/sys/ptrace.h b/sysdeps/unix/sysv/linux/x86/sys/ptrace.h
index 6d4605b6ed21..e077f2ad9437 100644
--- a/sysdeps/unix/sysv/linux/x86/sys/ptrace.h
+++ b/sysdeps/unix/sysv/linux/x86/sys/ptrace.h
@@ -70,19 +70,19 @@ enum __ptrace_request
   PTRACE_SINGLESTEP = 9,
 #define PT_STEP PTRACE_SINGLESTEP
 
-  /* Get all general purpose registers used by a processes.  */
+  /* Get all general purpose registers used by a process.  */
   PTRACE_GETREGS = 12,
 #define PT_GETREGS PTRACE_GETREGS
 
-  /* Set all general purpose registers used by a processes.  */
+  /* Set all general purpose registers used by a process.  */
   PTRACE_SETREGS = 13,
 #define PT_SETREGS PTRACE_SETREGS
 
-  /* Get all floating point registers used by a processes.  */
+  /* Get all floating point registers used by a process.  */
   PTRACE_GETFPREGS = 14,
 #define PT_GETFPREGS PTRACE_GETFPREGS
 
-  /* Set all floating point registers used by a processes.  */
+  /* Set all floating point registers used by a process.  */
   PTRACE_SETFPREGS = 15,
 #define PT_SETFPREGS PTRACE_SETFPREGS
 
@@ -94,11 +94,11 @@ enum __ptrace_request
   PTRACE_DETACH = 17,
 #define PT_DETACH PTRACE_DETACH
 
-  /* Get all extended floating point registers used by a processes.  */
+  /* Get all extended floating point registers used by a process.  */
   PTRACE_GETFPXREGS = 18,
 #define PT_GETFPXREGS PTRACE_GETFPXREGS
 
-  /* Set all extended floating point registers used by a processes.  */
+  /* Set all extended floating point registers used by a process.  */
   PTRACE_SETFPXREGS = 19,
 #define PT_SETFPXREGS PTRACE_SETFPXREGS
 